<template>
	
	<!-- Show the full breadcrumb on larger screens -->
	<ul class="p-1 hidden sm:flex whitespace-nowrap">
		<li v-for="( crumb, level ) in levels" :key="crumb.url">
			<template v-if="level === 0">
				<router-link to="/" class="link">Home</router-link>
			</template>
			<template v-else>
				<span class="mx-1">&raquo;</span>
				<router-link :to="crumb.url" class="link">{{ crumb.name }}</router-link>
			</template>
		</li>
	</ul>

	<!-- Show a simple back button on smaller screens -->
	<div class="p-1 sm:hidden whitespace-nowrap font-medium" v-if="!isTopLevel">
		<router-link :to="previousLevel.url" class="link">&laquo; {{ this.previousLevel.name }}</router-link>
	</div>

</template>

<script>

/**
 * @typedef {object} Crumb
 * @property {string} name The display name of the crumb
 * @property {string} url The URL to the page 
 */

/**
 * Component responsible of showing a breadcrumb to the current page to the user.
 * On small screens, the entire breadcrumb is replaced with a simpler back button.
 */
export default {
	props: {
		/**
		 * @type Crumb[]
		 * The list of previous crumbs to display to the user. Should be null on the landing page.
		 */
		value: {
			type: Array,
			required: false
		}
	},
	computed: {
		
		/**
		 * @returns {Crumb[]} the full list of crumbs, including the landing page.
		 */
		levels() {
			return [ { name: 'Home', url: '/' }, ...( this.value ?? [] ) ];
		},

		/**
		 * @returns {boolean} true on the landing page, false otherwise.
		 */
		isTopLevel() {
			return !this.value || this.value.length === 0; 
		},

		/**
		 * @returns {Crumb} the previous level, if any; null otherwise.
		 */
		previousLevel() {
			return this.levels[ this.levels.length - 2 ] ?? null;
		}
	}
}
</script>
